/* Dokiel frame manager */
window.frameMgr = {
	fPathRoot: "ide:frame",
	fPathContentFrame: "ide:content/des:iframe",
	fPathNavBar: "ide:navigation",
	fPathQuest: "ide:outline/des:aside.tplQuestionnaire/des:ul.questions",
	fPathCondBtns: "ide:outline/des:aside.tplQuestionnaire/des:.condBtn",
	fPathDocBtn: "ide:menu/des:div.toolHome/des:a",
	fQuizList: [],
	fQuizIndex: "",
	fConds: {},
	fListeners: {initPage: [], loadPage: [], unloadPage: [], showSearch: [], resetSearch: []},
	fIsLocal: window.location.protocol == "file:",

	fStrings: ["Ce site utilise un système de mesure d\'audience qui nécessite l\'utilisation de cookies pour comprendre et améliorer l\'expérience du visiteur.", "",
		/*02*/      "Accepter", "Refuser",
		/*04*/      "Cookies", "Gestion des cookies",
		/*06*/      "La page demandée n\'existe pas sur ce site.\n\nVoulez-vous être redirigé vers la page d\'accueil ?", "",
		/*08*/      "Le chargement dynamique de ressources est désactivé en local (adresse commençant par file://).\n\nLes restrictions sécuritaires de votre navigateur interdisent l\'utilisation de certaines fonctionnalités telles que la recherche.", "Ce site a été conçu pour s\'adapter à votre situation à travers un questionnaire qui ne peut pas fonctionner quand celui-ci est consulté en local."],

	init: function () {
		try {
			this.fStore = new this.LocalStore();
			this.fRoot = scPaLib.findNode(this.fPathRoot);
			this.fFra = scPaLib.findNode(this.fPathContentFrame);
			this.fFra.initPage = function (pUrl, pTitle, pHash) {
				frameMgr.xLoadPage(pUrl, pTitle, pHash);
			};
			this.fFra.loadPage = function (pUri) {
				frameMgr.fireEvent("loadPage", pUri);
			};
			this.fFra.hashChange = function (pHash) {
				frameMgr.fHashCurrent = pHash;
				frameMgr.xUpdateHash();
			};
			this.fFra.hasConds = function () {
				return (frameMgr.fQuest ? true : false)
			}
			this.fFra.getConds = function () {
				return frameMgr.fConds
			};
			this.fFra.resetMenuContext = function (pUrl) {
				if (outMgr.hasPage(pUrl)) outMgr.resetRequestedItem();
			};
			this.fFra.setMenuContext = function (pUrl) {
				outMgr.setPageContextFromUrl(pUrl);
			};
			this.fFra.isPageVisible = function (pUrl) {
				return outMgr.isVisible(pUrl, null, "cnd");
			};
			this.fFra.unloadPage = function () {
				frameMgr.xUnloadPage()
			};
			this.fFra.fStore = this.fStore;
			this.fRootTitle = document.title;
			if (this.fIsLocal) this.fRoot.className = this.fRoot.className + " isLocal";
			if (typeof _CookieWarn == "undefined") _CookieWarn = false;
			if (_CookieWarn) {
				const vCookieWarnBar = this.fCookieWarnBar = scDynUiMgr.addElement("div", scPaLib.findNode(this.fPathRoot), "cookieWarnBar" + (localStorage.getItem("AcknowledgeAnalytics") ? " acknowledged" : ""), scPaLib.findNode(this.fPathRoot + "/chi:"));
				const vMsgBox = scDynUiMgr.addElement("span", vCookieWarnBar, "cookieWarnMsg");
				const vMsg = this.fStrings[_CookieWarn == "analytics" ? 0 : 1];
				vMsgBox.innerHTML = vMsg + " ";
				const vBtnOk = scDynUiMgr.addElement("a", vCookieWarnBar, "cookieWarnBtnOk");
				vBtnOk.setAttribute("role", "button");
				vBtnOk.href = "#";
				vBtnOk.innerHTML = '<span>' + this.fStrings[2] + '</span>';
				vBtnOk.onclick = function () {
					const vIsActive = localStorage.getItem("ActivateAnalytics");
					localStorage.setItem("ActivateAnalytics", true);
					localStorage.setItem("AcknowledgeAnalytics", true);
					frameMgr.fCookieWarnBar.classList.add("acknowledged");
					frameMgr.xSwitchClass(scPaLib.findNode("bod:"), "cookieWarnBar_on", "cookieWarnBar_off", true);
					if (!vIsActive) window.location.reload();
					return false;
				}
				const vBtnNok = scDynUiMgr.addElement("a", vCookieWarnBar, "cookieWarnBtnNok");
				vBtnNok.setAttribute("role", "button");
				vBtnNok.href = "#";
				vBtnNok.innerHTML = '<span>' + this.fStrings[3] + '</span>';
				vBtnNok.onclick = function () {
					const vIsActive = localStorage.getItem("ActivateAnalytics");
					localStorage.removeItem("ActivateAnalytics");
					localStorage.setItem("AcknowledgeAnalytics", true);
					frameMgr.fCookieWarnBar.classList.add("acknowledged");
					frameMgr.xSwitchClass(scPaLib.findNode("bod:"), "cookieWarnBar_on", "cookieWarnBar_off", true);
					if (vIsActive) window.location.reload();
					return false;
				}
				const vBtnBar = scDynUiMgr.addElement("a", scPaLib.findNode("ide:footer"), "cookieWarnBtnBar", scPaLib.findNode("ide:footer/chi:.btnSc"));
				vBtnBar.setAttribute("role", "button");
				vBtnBar.setAttribute("title", this.fStrings[5]);
				vBtnBar.href = "#";
				vBtnBar.innerHTML = '<span>' + this.fStrings[4] + '</span>';
				vBtnBar.onclick = function () {
					localStorage.removeItem("AcknowledgeAnalytics");
					frameMgr.fCookieWarnBar.classList.remove("acknowledged");
					frameMgr.xSwitchClass(scPaLib.findNode("bod:"), "cookieWarnBar_off", "cookieWarnBar_on", true);
					return false;
				}
				document.body.classList.add("cookieWarnBar_" + (localStorage.getItem("AcknowledgeAnalytics") ? "off" : "on"))
			}
			this.fQuest = scPaLib.findNode(this.fPathQuest);
			if (!this.fIsLocal && this.fQuest) {
				this.xInitQuestionnaire();
			}
			this.fRoot.className = this.fRoot.className + (this.fQuest ? " questPresent_yes questShow_no" : " questPresent_no");

			// HASH listener
			window.addEventListener("hashchange", function (pEvt) {
				let vHash = decodeURIComponent(window.location.hash);
				if (vHash.length > 0) vHash = vHash.substring(1);
				if (vHash == "outline") document.body.classList.toggle("outline", true);
				else document.body.classList.toggle("outline", false);
				vHash = vHash.split(":");
				if (vHash[0].indexOf("$") == 0) vHash.shift();
				const vPageURL = outMgr.getPageUrlFromId(vHash[0]);
				const vContext = vHash[0] + ":" + vHash[1];
				if (frameMgr.fPageCurrent === vPageURL) return;
				if (vPageURL && vHash.length > 2) vHash = vHash[2];
				else vHash = null;
				if (vContext) outMgr.setPageContextFromId(vContext);
				frameMgr.loadPage(vPageURL, vHash);
			}, false);

			scOnLoads[scOnLoads.length] = this;
		} catch (e) {
			scCoLib.log("ERROR - frameMgr.init : " + e)
		}
	},

	onLoad: function () {
		// init current page
		// Process page URL
		let vRequestedPageId = null;
		let vPageURL = null;
		let vContext = null;
		let vHash = null;
		if (window.location.search.length > 0) {
			const vCtxt = window.location.search.substring(1).split("&");
			let i = 0;
			const n = vCtxt.length;
			for (; i < n; i++) {
				const vCmd = vCtxt[i].split("=");
				switch (vCmd[0]) {
					case "p" :
						const vUrl = decodeURIComponent(vCmd[1]);
						if (vUrl.indexOf("co/") == 0) vPageURL = vUrl;
						break;
					case "h" :
						vHash = decodeURIComponent(vCmd[1]);
						break;
				}
			}
		}
		if (window.location.hash.length > 0) {
			vHash = decodeURIComponent(window.location.hash).substring(1).split(":");
			if (vHash[0].indexOf("$") == 0) vHash.shift();
			vRequestedPageId = vHash[0];
			vPageURL = outMgr.getPageUrlFromId(vRequestedPageId);
			if (vPageURL && vHash.length > 1) {
				if (isNaN(parseInt(vHash[1].substring(0, 1)))) vHash = vHash[1];
				else {
					vContext = vHash[0] + ":" + vHash[1];
					if (vHash.length > 2) vHash = vHash[2];
					else vHash = null;
				}
			} else vHash = null;
		}
		if (!this.fIsLocal && !vPageURL && this.fQuest && this.fQuest.getAttribute("data-startmode") == "showIfEmpty" && this.fQuizIndex == this.fQuizIndexDefault) {
			this.openQuestionnaire();
		}
		if (vRequestedPageId && !vPageURL) { // Page not found.
			if (confirm(this.fStrings[6])) this.loadPage(outMgr.getFirstPage());
		} else {
			if (!vPageURL) vPageURL = outMgr.getFirstPage();
			if (vContext) outMgr.setPageContextFromId(vContext);
			this.loadPage(vPageURL, vHash);
		}
		if (this.fIsLocal) alert(this.fStrings[8] + (this.fQuest ? "\n\n" + this.fStrings[9] : ""));
	},

	loadSortKey: "Z",

	registerListener: function (pListener, pFunc) {
		if (this.fListeners[pListener]) this.fListeners[pListener].push(pFunc);
		else scCoLib.log("ERROR - frameMgr.registerListener - non-existent listener : " + pListener);
	},

	loadPage: function (pUrl, pHash) {
		if (pUrl && pUrl.length > 0) this.fFra.contentWindow.location.replace(scServices.scLoad.getRootUrl() + "/" + pUrl + "?ts=" + scServices.id + (pHash ? "#" + pHash : ""));
	},

	reload: function () {
		if (this.fPageCurrent) this.loadPage(this.fPageCurrent);
	},

	goToFirstPage: function () {
		this.loadPage(outMgr.getFirstPage());
	},

	hasNextPage: function () {
		return outMgr.hasNextPage(this.fPageCurrent);
	},

	hasPreviousPage: function () {
		return outMgr.hasPreviousPage(this.fPageCurrent);
	},

	goToNextPage: function () {
		if (this.hasNextPage()) this.loadPage(outMgr.getNextPage(this.fPageCurrent));
	},

	goToPreviousPage: function () {
		if (this.hasPreviousPage()) this.loadPage(outMgr.getPreviousPage(this.fPageCurrent));
	},

	getPageRank: function () {
		return outMgr.getPageRank(this.fPageCurrent);
	},

	getPageCount: function () {
		return outMgr.getPageCount();
	},

	scrollTo: function (pId) {
		this.loadPage(this.fPageCurrent, pId);
	},

	fireEvent: function (pListener, pParam) {
		if (this.fListeners[pListener]) for (let i = 0; i < this.fListeners[pListener].length; i++) this.fListeners[pListener][i](pParam);
		else scCoLib.log("ERROR - frameMgr.fireEvent - non-existent listener : " + pListener);
	},

	addFormulaCondition: function (pId, pCond) {
		if (!this.fConds[pId]) this.fConds[pId] = pCond;
	},

	openQuestionnaire: function () {
		this.xSwitchClass(this.fRoot, "questShow_no", "questShow_yes", true);
	},

	closeQuestionnaire: function () {
		this.xSwitchClass(this.fRoot, "questShow_yes", "questShow_no", true);
	},
	resetQuestionnaire: function () {
		for (let i = 0; i < this.fQuizList.length; i++) {
			const vQuiz = this.fQuizList[i];
			for (let j = 0; j < vQuiz.choices.length; j++) {
				vQuiz.choices[j].fInput.checked = false;
			}
			if (vQuiz.defaultIndex >= 0) vQuiz.choices[vQuiz.defaultIndex].fInput.checked = true;
		}
		this.refreshQuestionnaire();
	},
	refreshQuestionnaire: function () {
		scCoLib.log("frameMgr refreshQuestionnaire");
		let vAnyQuizIsChecked = false;
		const vQuestIndex = [];
		for (var vCond in this.fConds) {
			this.fConds[vCond].value = this.fConds[vCond].default;
		}
		for (let i = 0; i < this.fQuizList.length; i++) {
			const vQuiz = this.fQuizList[i];
			let vChoiceIndex = 0;
			let vQuizIsChecked = false;
			for (var j = 0; j < vQuiz.choices.length; j++) {
				var vChoice = vQuiz.choices[j];
				if (vChoice.fInput.checked) {
					vChoiceIndex = j + 1;
					vQuizIsChecked = vAnyQuizIsChecked = true;
					break;
				}
			}
			for (var j = 0; j < vQuiz.choices.length; j++) {
				var vChoice = vQuiz.choices[j];
				for (let k = 0; k < vChoice.fConds.length; k++) {
					const vChoiceCond = vChoice.fConds[k];
					var vCond = this.fConds[vChoiceCond.id];
					if (vChoice.fInput.checked) {
						vCond.value = vChoiceCond.value;
					}
				}
				this.xSwitchClass(vChoice, "isSelected_", "isSelected_" + vChoice.fInput.checked, true, false);
			}
			if (vQuiz.nullChoice) {
				this.xSwitchClass(vQuiz.nullChoice, "isSelected_", "isSelected_" + vQuiz.nullChoice.fInput.checked, true, false);
				if (vQuiz.nullChoice.fInput.checked) vAnyQuizIsChecked = true;
			}
			this.xSwitchClass(vQuiz.root, "isSelected_", "isSelected_" + (vQuizIsChecked || ((typeof vQuiz.nullChoice != "undefined") && vQuiz.nullChoice.fInput.checked)), true, false);
			vQuestIndex.push(vChoiceIndex);
		}
		this.xSwitchClass(this.fRoot, "questActive_", "questActive_" + vAnyQuizIsChecked, true, false);
		this.fQuizIndex = "$" + vQuestIndex.join(".");
		if ("searchMgr" in window) searchMgr.reset();
		outMgr.setConds(this.fConds);
		if (this.fPageCurrent) {
			this.xUpdateHash();
			if (outMgr.isVisible(this.fPageCurrent)) {
				this.reload();
			} else {
				this.goToFirstPage();
			}
		}
	},

	toggleMenu: function (pMnuClosed) {
		frameMgr.xToggleMenu(pMnuClosed);
	},

	/* === Callback functions =================================================== */
	sPrv: function () {
		frameMgr.goToPreviousPage();
		return false;
	},

	sNxt: function () {
		frameMgr.goToNextPage();
		return false;
	},

	/* === Private functions ==================================================== */
	xLoadPage: function (pUri, pTitle, pHash) {
		try {
			if (outMgr.fMenus.length == 0) return; // The menu manager is not yet init - no point in going on
			document.title = pTitle + (this.fRootTitle != pTitle ? " [" + this.fRootTitle + "]" : "");
			this.fFra.title = pTitle;
			const vDocBtn = scPaLib.findNode(this.fPathDocBtn);
			if (outMgr.hasPage(pUri)) {
				this.toggleMenu(false);
				vDocBtn.href = scServices.scLoad.getPathFromRoot(vDocBtn.fSrc.url);
				this.xSwitchClass(vDocBtn, "mnu_ret_yes", "mnu_ret_no", true);
				this.xSwitchClass(this.fRoot, "documentation_no", "documentation_yes", true);
			} else {
				this.toggleMenu(true);
				this.xSwitchClass(this.fRoot, "documentation_yes", "documentation_no", true);
				if (this.fLastMenuPage) {
					vDocBtn.href = scServices.scLoad.getPathFromRoot(this.fLastMenuPage);
					this.xSwitchClass(vDocBtn, "mnu_ret_no", "mnu_ret_yes", true);
				}
			}
			if (pUri == vDocBtn.fSrc.url) {
				this.xSwitchClass(this.fRoot, "home_no", "home_yes", true);
			} else {
				this.xSwitchClass(this.fRoot, "home_yes", "home_no", true);
			}
			this.fPageCurrent = pUri;
			this.fHashCurrent = pHash;
			this.fireEvent("initPage", pUri);
			this.fStore.set("lastPage", pUri);
			this.xUpdateHash();
		} catch (e) {
			scCoLib.log("ERROR - frameMgr.xLoadPage : " + e)
		}
	},

	xUpdateHash: function () {
		try {
			const vNewHash = [];
			let vId = null;
			if (outMgr.getRootPage() != this.fPageCurrent) {
				vId = outMgr.getPageContextId();
				if (!vId) vId = outMgr.getPageIdFromUrl(this.fPageCurrent);
			}
			if (this.fQuizIndex) vNewHash.push(this.fQuizIndex);
			if (vId) vNewHash.push(vId);
			if (this.fHashCurrent) vNewHash.push(this.fHashCurrent);
			if (vNewHash.length > 0) window.location.replace(scCoLib.hrefBase() + "#" + vNewHash.join(":"));
			else history.replaceState(null, null, ' ');
		} catch (e) {
		}
	},

	xUnloadPage: function () {
		if (this.fPageCurrent && outMgr.hasPage(this.fPageCurrent)) this.fLastMenuPage = this.fPageCurrent;
		this.fireEvent("unloadPage");
	},

	xInitQuestionnaire: function () {
		scCoLib.log("frameMgr xInitQuestionnaire");
		let vQuizIndex = [];
		const vQuizIndexDefault = [];
		const vDefaultConds = JSON.parse(this.fQuest.getAttribute("data-conds"));
		for (var i = 0; i < vDefaultConds.length; i++) {
			const vDefaultCond = vDefaultConds[i].split(":");
			const vValue = vDefaultCond[1] == "true";
			this.fConds[vDefaultCond[0]] = {
				default: vValue, value: vValue, getValue: function () {
					return this.value
				}
			};
		}

		if (window.location.hash.length > 0) {
			const vHash = decodeURIComponent(window.location.hash).substring(1).split(":");
			if (vHash[0].indexOf("$") == 0) {
				vQuizIndex = vHash[0].substring(1).split(".");
			}
		}
		const vCondBtns = scPaLib.findNodes(this.fPathCondBtns);
		if (vCondBtns.length > 0) {
			const vQuizCtrl = {};
			for (var i = 0; i < vCondBtns.length; i++) {
				const vCondBtn = vCondBtns[i];
				let vConds = vCondBtn.fConds = JSON.parse(vCondBtn.getAttribute("data-conds"));
				if (vConds[0].length > 0) {
					for (let j = 0; j < vConds.length; j++) {
						const vCond = vConds[j].split(":");
						vConds[j] = {id: vCond[0], value: vCond[1] == "true"};
					}
				} else vConds = null;
				const vInput = vCondBtn.fInput = scPaLib.findNode("des:input", vCondBtn);
				vInput.onclick = function () {
					frameMgr.refreshQuestionnaire()
				};
				const vQuizName = vInput.getAttribute("name");
				if (!vQuizCtrl[vQuizName]) this.fQuizList[this.fQuizList.length] = vQuizCtrl[vQuizName] = {
					choices: [],
					name: vQuizName,
					root: scPaLib.findNode("anc:li", vCondBtn)
				};
				if (vConds) vQuizCtrl[vQuizName].choices.push(vCondBtn);
				else vQuizCtrl[vQuizName].nullChoice = vCondBtn;
			}
			for (var i = 0; i < this.fQuizList.length; i++) {
				const vQuiz = this.fQuizList[i];
				vQuiz.defaultIndex = scCoLib.toInt(vQuiz.root.getAttribute("data-default")) || 0;
				vQuizIndexDefault.push(vQuiz.defaultIndex);
				vQuiz.defaultIndex--;
				if (vQuiz.defaultIndex >= 0) vQuiz.choices[vQuiz.defaultIndex].fInput.checked = true;
			}
			if (vQuizIndex.length == this.fQuizList.length) {
				for (var i = 0; i < this.fQuizList.length; i++) {
					if (vQuizIndex[i] != "0") {
						try {
							this.fQuizList[i].choices[scCoLib.toInt(vQuizIndex[i]) - 1].fInput.checked = true;
						} catch (e) {
						}
					}
				}
			}
		}
		this.fQuizIndexDefault = "$" + vQuizIndexDefault.join(".");
		frameMgr.refreshQuestionnaire();
	},

	xToggleMenu: function (pIsMnuClosed) {
		if (pIsMnuClosed) {
			this.xSwitchClass(this.fRoot, "tplMnuCls_no", "tplMnuCls_yes", true);
		} else {
			this.xSwitchClass(this.fRoot, "tplMnuCls_yes", "tplMnuCls_no", true);
		}
	},

	/* === Utilities ============================================================ */
	/** frameMgr.xAddBtn : Add a HTML button to a parent node. */
	xAddBtn: function (pParent, pClassName, pCapt, pTitle, pNxtSib) {
		const vBtn = pParent.ownerDocument.createElement("a");
		vBtn.className = pClassName;
		vBtn.fName = pClassName;
		vBtn.href = "#";
		vBtn.target = "_self";
		if (pTitle) vBtn.setAttribute("title", pTitle);
		if (pCapt) vBtn.innerHTML = "<span>" + pCapt + "</span>"
		if (pNxtSib) pParent.insertBefore(vBtn, pNxtSib)
		else pParent.appendChild(vBtn);
		return vBtn;
	},

	/** frameMgr.xSwitchClass - replace a class name. */
	xSwitchClass: function (pNode, pClassOld, pClassNew, pAddIfAbsent, pMatchExact) {
		const vAddIfAbsent = typeof pAddIfAbsent == "undefined" ? false : pAddIfAbsent;
		const vMatchExact = typeof pMatchExact == "undefined" ? true : pMatchExact;
		const vClassName = pNode.className;
		const vReg = new RegExp("\\b" + pClassNew + "\\b");
		if (vMatchExact && vClassName.match(vReg)) return;
		let vClassFound = false;
		if (pClassOld && pClassOld != "") {
			if (vClassName.indexOf(pClassOld) == -1) {
				if (!vAddIfAbsent) return;
				else if (pClassNew && pClassNew != '') pNode.className = vClassName + " " + pClassNew;
			} else {
				const vCurrentClasses = vClassName.split(' ');
				const vNewClasses = new Array();
				let i = 0;
				const n = vCurrentClasses.length;
				for (; i < n; i++) {
					const vCurrentClass = vCurrentClasses[i];
					if (vMatchExact && vCurrentClass != pClassOld || !vMatchExact && vCurrentClass.indexOf(pClassOld) != 0) {
						vNewClasses.push(vCurrentClasses[i]);
					} else {
						if (pClassNew && pClassNew != '') vNewClasses.push(pClassNew);
						vClassFound = true;
					}
				}
				pNode.className = vNewClasses.join(' ');
			}
		}
		return vClassFound;
	},

	/** Local Storage API (localStorage/userData/cookie) */
	LocalStore: function (pId) {
		if (pId && !/^[a-z][a-z0-9]+$/.exec(pId)) throw new Error("Invalid store name");
		this.fId = pId || "";
		this.fRootKey = document.location.pathname.substring(0, document.location.pathname.lastIndexOf("/")) + "/";
		if (typeof localStorage != "undefined") {
			this.get = function (pKey) {
				const vRet = localStorage.getItem(this.fRootKey + this.xKey(pKey));
				return (typeof vRet == "string" ? unescape(vRet) : null)
			};
			this.set = function (pKey, pVal) {
				localStorage.setItem(this.fRootKey + this.xKey(pKey), escape(pVal))
			};
		} else if (window.ActiveXObject) {
			this.get = function (pKey) {
				this.xLoad();
				return this.fIE.getAttribute(this.xEsc(pKey))
			};
			this.set = function (pKey, pVal) {
				this.fIE.setAttribute(this.xEsc(pKey), pVal);
				this.xSave()
			};
			this.xLoad = function () {
				this.fIE.load(this.fRootKey + this.fId)
			};
			this.xSave = function () {
				this.fIE.save(this.fRootKey + this.fId)
			};
			this.fIE = document.createElement('div');
			this.fIE.style.display = 'none';
			this.fIE.addBehavior('#default#userData');
			document.body.appendChild(this.fIE);
		} else {
			this.get = function (pKey) {
				const vReg = new RegExp(this.xKey(pKey) + "=([^;]*)");
				const vArr = vReg.exec(document.cookie);
				if (vArr && vArr.length == 2) return (unescape(vArr[1])); else return null
			};
			this.set = function (pKey, pVal) {
				document.cookie = this.xKey(pKey) + "=" + escape(pVal)
			};
		}
		this.xKey = function (pKey) {
			return this.fId + this.xEsc(pKey)
		};
		this.xEsc = function (pStr) {
			return "LS" + pStr.replace(/ /g, "_")
		};
	}
};
