/* === Dokiel outline manager =============================================== */
window.outMgr = {
	fPathRoot: "ide:outline/chi:div.tplMenuScroll",
	fPathTools: "ide:header/des:.tplTools",
	fPathContext: "ide:header/des:.tplContextMenu",
	fPathBranches: "des:div.mnu_b",
	fTarget: "contentFrame",
	fUrlOutline: null,
	fPruneTools: true,
	fMenus: [],
	fUrlHashTable: {},
	fIdHashTable: {},
	sFilterTgleClosed: scPaLib.compileFilter(".mnu_tgle_c"),
	fMaxFilterDisplay: 100,
	fDefaultMenu: 0,
	fOverflowMethod: "hidden",
	fWheelScrollFactor: 6,
	fSelectOneEntry: false,
	fClassSuffixSame: "same",
	fIsLocal: window.location.protocol == "file:",

	fStrings: ["défilement haut", "Faire défiler le menu vers le haut",
		/*02*/       "défilement bas", "Faire défiler le menu vers le bas",
		/*04*/       "Ouvrir le menu \'%s\'", "Fermer le menu \'%s\'",
		/*04*/       "Documentation", ""],


	/* === Public functions ===================================================== */
	init: function (pSelectOneEntry) {
		this.fSelectOneEntry = pSelectOneEntry;
		this.fIsLocal = window.location.protocol == "file:";
		this.fFilterIsClosed = scPaLib.compileFilter(".mnu_sub_c");
		this.fFilterIsBranch = scPaLib.compileFilter(".mnu_b");

		scOnLoads[scOnLoads.length] = this;
	},

	onLoad: function () {
		try {
			frameMgr.registerListener("initPage", this.sOnLoadPage);
			frameMgr.registerListener("showSearch", this.sOnFilter);
			frameMgr.registerListener("resetSearch", this.sOnReset);

			this.fRoot = scPaLib.findNode(this.fPathRoot);
			this.fTools = scPaLib.findNode(this.fPathTools);
			this.fContext = scPaLib.findNode(this.fPathContext);
			const vOutline = this.xGetOutline();

			const iHashTableInit = function (pItem) {
				if (pItem.url && pItem.id) {
					outMgr.fUrlHashTable[pItem.url] = pItem.id;
					outMgr.fIdHashTable[pItem.id] = pItem.url;
				}
				if (pItem.children) {
					for (let i = 0; i < pItem.children.length; i++) iHashTableInit(pItem.children[i]);
				}
			};
			const iPrune = function (pItem) {
				pItem.prn = true;
				if (pItem.children) {
					for (let i = 0; i < pItem.children.length; i++) iPrune(pItem.children[i]);
				}
			};
			const iTitleOverload = function (pItem, pKey) {
				if (vOutline.titleOverloads[pKey]) {
					pItem.title = pItem.label;
					pItem.label = vOutline.titleOverloads[pKey];
				}
				if (pItem.children) {
					for (let i = 0; i < pItem.children.length; i++) iTitleOverload(pItem.children[i], pKey + String(i));
				}
			};

			const vSrcMenu = vOutline.menu;
			iHashTableInit(vSrcMenu);
			if (vOutline.titleOverloads) iTitleOverload(vSrcMenu, "");
			const vSrcTools = vOutline.tools;
			iHashTableInit(vSrcTools);
			const vSrcOrphans = vOutline.orphans;
			if (vSrcOrphans) {
				iHashTableInit(vSrcOrphans);
			}

			// Init du menu
			vSrcMenu.url = null
			const vToolsInMenu = JSON.parse(JSON.stringify((vSrcTools)));
			if (vToolsInMenu.children && vToolsInMenu.children.length > 0) {
				vToolsInMenu.url = null;
				if (this.fPruneTools) iPrune(vToolsInMenu);
				vSrcMenu.children.push(vToolsInMenu);
			}
			if (vSrcOrphans) {
				const vOrphansInMenu = JSON.parse(JSON.stringify(vSrcOrphans));
				iPrune(vOrphansInMenu);
				vSrcMenu.children.push(vOrphansInMenu);
			}

			// Init des outils
			if (!vSrcTools.children) vSrcTools.children = [];
			vSrcTools.children.unshift(JSON.parse(JSON.stringify(vSrcMenu.children[0])));
			vSrcTools.children[0].source = "refHome";
			vSrcTools.children[0].className = "toolHome";
			vSrcTools.children[0].label = this.fStrings[6];
			vSrcTools.url = null;

			const vMenu = new this.MenuManager(this.fRoot, vSrcMenu, {
				target: this.fTarget,
				addScroller: true,
				contextRoot: this.fContext,
				selectOneEntry: this.fSelectOneEntry
			});
			vMenu.rebuildMenu();
			this.fMenus.push(vMenu);

			const vTools = new this.MenuManager(this.fTools, vSrcTools, {
				target: this.fTarget,
				addTitleAttributes: true,
				neverFilter: true
			});
			vTools.rebuildMenu();
			this.fMenus.push(vTools);

		} catch (e) {
			scCoLib.log("ERROR - outMgr.onLoad: " + e);
		}
	},

	/** outMgr.getPageUrlFromId : return the URL of the page who's ID is provided */
	getPageUrlFromId: function (pId) {
		return this.fIdHashTable[pId];
	},

	/** outMgr.getPageIdFromUrl : return the ID of the page who's URL is provided */
	getPageIdFromUrl: function (pUrl) {
		return this.fUrlHashTable[pUrl];
	},

	/** outMgr.getCurrentContextId : return the context ID of the current page in the given menu */
	getPageContextId: function (pMenuIndex) {
		const vMenu = this.fMenus[(typeof pMenuIndex == "undefined") ? this.fDefaultMenu : pMenuIndex];
		return vMenu.buildContextId(vMenu.fCurrItem);
	},

	/** outMgr.setPageContextFromId : set the requested page in the given menu from a context ID */
	setPageContextFromId: function (pContext, pMenuIndex) {
		const vMenu = this.fMenus[(typeof pMenuIndex == "undefined") ? this.fDefaultMenu : pMenuIndex];
		vMenu.setRequestedItemFromContextId(pContext);
	},

	/** outMgr.setPageContextFromUrl : set the requested page in the given menu from a url */
	setPageContextFromUrl: function (pUrl, pMenuIndex) {
		const vMenu = this.fMenus[(typeof pMenuIndex == "undefined") ? this.fDefaultMenu : pMenuIndex];
		vMenu.setRequestedItemFromUrl(pUrl);
	},

	/** outMgr.resetRequestedItem : reset the requested page in the given menu */
	resetRequestedItem: function (pMenuIndex) {
		const vMenu = this.fMenus[(typeof pMenuIndex == "undefined") ? this.fDefaultMenu : pMenuIndex];
		vMenu.fRequestedItem = null;
	},

	/** outMgr.getRootPage : return the URL of the current displayed menu's root item. */
	getRootPage: function (pMenuIndex) {
		if (typeof pMenuIndex == "undefined") pMenuIndex = this.fDefaultMenu;
		return (this.fMenus[pMenuIndex] ? this.fMenus[pMenuIndex].getRootPageUrl() : null);
	},

	/** outMgr.getFirstPage : return the URL of the current displayed menu's first visible item. */
	getFirstPage: function (pMenuIndex) {
		if (typeof pMenuIndex == "undefined") pMenuIndex = this.fDefaultMenu;
		return (this.fMenus[pMenuIndex] ? this.fMenus[pMenuIndex].getFirstPageUrl() : null);
	},

	/** outMgr.hasPage */
	hasPage: function (pUrl, pMenuIndex) {
		if (typeof pMenuIndex == "undefined") pMenuIndex = this.fDefaultMenu;
		return (this.fMenus[pMenuIndex] ? this.fMenus[pMenuIndex].hasPage(pUrl) : null);
	},

	/** outMgr.isVisible */
	isVisible: function (pUrl, pMenuIndex, pReason) {
		if (typeof pMenuIndex == "undefined" || pMenuIndex == null) pMenuIndex = this.fDefaultMenu;
		return (this.fMenus[pMenuIndex] ? this.fMenus[pMenuIndex].isVisible(pUrl, pReason) : null);
	},

	/** outMgr.hasNextPage */
	hasNextPage: function (pUrl, pMenuIndex) {
		if (typeof pMenuIndex == "undefined") pMenuIndex = this.fDefaultMenu;
		return (this.fMenus[pMenuIndex] ? (this.fMenus[pMenuIndex].getNextPageUrl(pUrl, true) ? true : false) : null);
	},

	/** outMgr.hasPreviousPage */
	hasPreviousPage: function (pUrl, pMenuIndex) {
		if (typeof pMenuIndex == "undefined") pMenuIndex = this.fDefaultMenu;
		return (this.fMenus[pMenuIndex] ? (this.fMenus[pMenuIndex].getPreviousPageUrl(pUrl, true) ? true : false) : null);
	},

	/** outMgr.getNextPage : return the URL of next visible item of the given url in the current displayed menu. */
	getNextPage: function (pUrl, pMenuIndex) {
		if (typeof pMenuIndex == "undefined") pMenuIndex = this.fDefaultMenu;
		return (this.fMenus[pMenuIndex] ? this.fMenus[pMenuIndex].getNextPageUrl(pUrl) : null);
	},

	/** outMgr.getPreviousPage : return the URL of previous visible item of the given url in the current displayed menu. */
	getPreviousPage: function (pUrl, pMenuIndex) {
		if (typeof pMenuIndex == "undefined") pMenuIndex = this.fDefaultMenu;
		return (this.fMenus[pMenuIndex] ? this.fMenus[pMenuIndex].getPreviousPageUrl(pUrl) : null);
	},

	/** outMgr.getPageCount : return the visible page cout the current displayed menu. */
	getPageCount: function (pMenuIndex) {
		if (typeof pMenuIndex == "undefined") pMenuIndex = this.fDefaultMenu;
		return (this.fMenus[pMenuIndex] ? this.fMenus[pMenuIndex].getPageCount() : null);
	},

	/** outMgr.getPreviousPage : return the rank of the given url in the current displayed menu. */
	getPageRank: function (pUrl, pMenuIndex) {
		if (typeof pMenuIndex == "undefined") pMenuIndex = this.fDefaultMenu;
		return (this.fMenus[pMenuIndex] ? this.fMenus[pMenuIndex].getPageRank(pUrl) : null);
	},

	/** outMgr.setConds : set the condition list and rebuild menus. */
	setConds: function (pConds) {
		scCoLib.log("outMgr setConds");
		this.fConds = pConds;
		for (let i = 0; i < this.fMenus.length; i++) {
			this.fMenus[i].setConds(pConds);
		}
	},

	/* === Callback functions =================================================== */
	/** outMgr.sOnLoadPage : Page load callback. */
	sOnLoadPage: function (pUri) {
		for (let i = 0; i < outMgr.fMenus.length; i++) outMgr.fMenus[i].loadPage(pUri);
	},
	/** outMgr.sOnFilter : Filter callback : called on a successful search. */
	sOnFilter: function (pPageList) {
		for (let i = 0; i < outMgr.fMenus.length; i++) outMgr.fMenus[i].applyFilter(pPageList);
	},
	/** outMgr.sOnReset : Filter reset callback : called search reset. */
	sOnReset: function () {
		for (let i = 0; i < outMgr.fMenus.length; i++) outMgr.fMenus[i].resetFilter();
	},


	/* === Private functions ==================================================== */
	/** outMgr.xGetOutline : Load and return the full outline description object. */
	xGetOutline: function () {
		try {
			let vOutTxt = sc$("outlineSource").textContent;
			if (vOutTxt.indexOf("/*<![CDATA[*/")===0) vOutTxt = vOutTxt.substring(13, vOutTxt.length-7);
			return JSON.parse(vOutTxt);
		} catch (e) {
			scCoLib.log("ERROR outMgr.xGetOutline : cannot parse outlineSource")
		}
	},

	/* === Utilities ============================================================ */

	/** outMgr.xAddBtn : Add a HTML button to a parent node. */
	xAddBtn: frameMgr.xAddBtn,

	/** outMgr.xSwitchClass - replace a class name. */
	xSwitchClass: frameMgr.xSwitchClass,

	loadSortKey: "A"
};

/** outMgr.MenuManager - Menu manager class. */
outMgr.MenuManager = function (pRoot, pOutline, pOpt) {
	try{
		scCoLib.log("outMgr MenuManager");
		this.fOpt = {target:"_self",addScroller:false,addTitleAttributes:false,contextRoot:null,neverFilter:false,selectOneEntry:false};
		if (typeof pOpt != "undefined"){
			if (typeof pOpt.target != "undefined") this.fOpt.target = pOpt.target;
			if (typeof pOpt.addScroller != "undefined") this.fOpt.addScroller = pOpt.addScroller;
			if (typeof pOpt.addTitleAttributes != "undefined") this.fOpt.addTitleAttributes = pOpt.addTitleAttributes;
			if (typeof pOpt.contextRoot != "undefined") this.fOpt.contextRoot = pOpt.contextRoot;
			if (typeof pOpt.neverFilter != "undefined") this.fOpt.neverFilter = pOpt.neverFilter;
			if (typeof pOpt.selectOneEntry != "undefined") this.fOpt.selectOneEntry = pOpt.selectOneEntry;
		}
		this.fRoot = pRoot;
		this.fOutline = pOutline;
		this.fRoot.fSrc = pOutline;
		this.fFilter = false;
		const vConds = this.fConds = {};
		for (const vCond in outMgr.fConds){
			vConds[vCond] = outMgr.fConds[vCond].getValue();
		}
		let vFirstItem = null;
		const vCondIndex = this.fCondIndex = {};
		const vItemIndex = this.fItemIndex = {};
		const iOutlineInit = function (pItem) {
			if (pItem.url) {
				if (!vItemIndex[pItem.url]) vItemIndex[pItem.url] = [];
				if (!vFirstItem) vFirstItem = pItem;
				vItemIndex[pItem.url].push(pItem);
			}
			if (pItem.cond) {
				const vCond = pItem.cond.split(":");
				const vCondId = vCond[0];
				const vCondValue = vCond[1] == "true";
				pItem.cond = {id: vCondId, value: vCondValue};
				if (!vCondIndex[vCondId]) vCondIndex[vCondId] = [];
				vCondIndex[vCondId].push(pItem);
				if (typeof vConds[vCondId] == "undefined") vConds[vCondId] = vCondValue;
				pItem.cnd = pItem.cond.value == vConds[vCondId];
			} else pItem.cnd = true;
			if (pItem.children) {
				for (let i = 0; i < pItem.children.length; i++) {
					const vChi = pItem.children[i];
					vChi.par = pItem;
					if (i < pItem.children.length - 1) vChi.ctxNxt = pItem.children[i + 1];
					if (i > 0) vChi.ctxPrv = pItem.children[i - 1];
					vChi.idx = i;
					iOutlineInit(vChi);
				}
			}
		};
		iOutlineInit(this.fOutline);
		const iOutlineWalker = function (pItem) {
			if (pItem.children) pItem.nxt = pItem.children[0];
			else if (pItem.ctxNxt) pItem.nxt = pItem.ctxNxt;
			else if (pItem.par) {
				let vPar = pItem.par;
				while (vPar && !vPar.ctxNxt) vPar = vPar.par;
				if (vPar && vPar.ctxNxt) pItem.nxt = vPar.ctxNxt;
			}
			if (typeof pItem.idx != "undefined" && pItem.idx == 0) pItem.prv = pItem.par;
			else {
				let vPrv = pItem.ctxPrv;
				while (vPrv && typeof vPrv.children != "undefined") vPrv = vPrv.children[vPrv.children.length - 1];
				if (vPrv) pItem.prv = vPrv;
			}
			if (pItem.children) {
				for (let i = 0; i < pItem.children.length; i++) {
					iOutlineWalker(pItem.children[i]);
				}
			}
		};
		iOutlineWalker(this.fOutline);
		this.fFirstItem = vFirstItem;
		this.fFirstFilteredItem = null;

		if (this.fOpt.addScroller) this.buildMenuScroller();
		if (this.fOpt.contextRoot) this.fContext = scDynUiMgr.addElement("span",this.fOpt.contextRoot,"ctx_root");

	} catch(e){scCoLib.log("outMgr.MenuManager init : "+e);}
}
outMgr.MenuManager.prototype = {
	/** MenuManager.buildMenuScroller - build a menu scroller infrastructure. */
	buildMenuScroller : function() {
		// Init Scroll
		this.fRoot.fMgr = this;
		this.fScrollerEnabled = true;
		this.fRoot.style.overflow = outMgr.fOverflowMethod;
		const vFra = this.fRoot.parentNode;

		// Init Scroll up button
		this.fSrlUp = scDynUiMgr.addElement("div", vFra, "mnuSrlUpFra", this.fRoot);
		this.fSrlUp.fMgr = this;
		this.fSrlUp.onclick = function(){
			this.fMgr.fSpeed -= 2;
		}
		this.fSrlUp.onmouseover = function(){
			if(this.fMgr.fSpeed >= 0) {
				this.fMgr.fSpeed = -2; 
				scTiLib.addTaskNow(this.fMgr);
			}
		}
		this.fSrlUp.onmouseout = function(){
			this.fMgr.fSpeed = 0;
		}
		this.fSrlUpBtn = outMgr.xAddBtn(this.fSrlUp, "mnuSrlUpBtn", outMgr.fStrings[0], outMgr.fStrings[1]);
		this.fSrlUpBtn.fMgr = this;
		this.fSrlUpBtn.onclick = function(){
			this.fMgr.setScrollStep(-20); 
			return false;
		}
		// Init Scroll down button
		this.fSrlDwn = scDynUiMgr.addElement("div", vFra, "mnuSrlDwnFra");
		this.fSrlDwn.fMgr = this;
		this.fSrlDwn.onclick = function(){
			this.fMgr.fSpeed += 2;
		}
		this.fSrlDwn.onmouseover = function(){
			if(this.fMgr.fSpeed <= 0) {
				this.fMgr.fSpeed = 2; 
				scTiLib.addTaskNow(this.fMgr);
			}
		}
		this.fSrlDwn.onmouseout = function(){
			this.fMgr.fSpeed = 0;
		}
		this.fSrlDwnBtn = outMgr.xAddBtn(this.fSrlDwn, "mnuSrlDwnBtn", outMgr.fStrings[2], outMgr.fStrings[3]);
		this.fSrlDwnBtn.fMgr = this;
		this.fSrlDwnBtn.onclick = function(){
			this.fMgr.setScrollStep(20);
			return false;
		}
		// Init scroll manager
		this.checkScrollBtns();
		this.ensureVisible();
		scSiLib.addRule(this.fRoot, this);
		this.fRoot.onscroll = function(){this.fMgr.checkScrollBtns()};
		this.fRoot.onmousewheel = function(){this.fMgr.setScrollStep(Math.round(-event.wheelDelta/(scCoLib.isIE ? 60 : 40)*outMgr.fWheelScrollFactor))}; //IE, Safari, Chrome, Opera.
		if(this.fRoot.addEventListener) this.fRoot.addEventListener('DOMMouseScroll', function(pEvent){this.fMgr.setScrollStep(pEvent.detail*outMgr.fWheelScrollFactor)}, false);

	},
	/** MenuManager.buildSubMenu - build the sub menu of a given root dom node. */
	buildSubMenu : function (pRoot, pHidden) {
		let i, vChi, vUl, vBtn, vTyp, vLblTxt;
		for (i=0; i< pRoot.fSrc.children.length; i++){
			vChi = pRoot.fSrc.children[i];
			if ((!this.fFilter && !vChi.prn || this.fFilter && vChi.vis) && vChi.cnd){
				vTyp = vChi.children ? "b" : "l";
				this.buildMenuEntry(pRoot, vChi, pHidden);
				if (vTyp == "b"){
					vLblTxt = vChi.fLnk.textContent || vChi.fLnk.innerText;
					vBtn = outMgr.xAddBtn(vChi.fLbl,"mnu_tgle_c",">", outMgr.fStrings[4].replace("%s", vLblTxt), vChi.fLnk);
					vBtn.onclick = this.sToggleMnuItem;
					vBtn.fLblTxt = vLblTxt;
					vUl = scDynUiMgr.addElement("ul",vChi.fLi,"mnu_sub mnu_sub_c");
					vChi.fLbl.fTglBtn = vBtn;
					vChi.fLnk.fTglBtn = vBtn;
					vUl.fTglBtn = vBtn;
					vUl.fSrc = vChi;
					vUl.fMgr = this;
					vBtn.fLbl = vChi.fLbl;
					vBtn.fUl = vUl
					vChi.fUl = vUl;
				}
			}
		}
		pRoot.fBuilt = true;
		if (this.fOpt.addScroller) this.checkScrollBtns();
	},
	/** MenuManager.buildMenuEntry - build the menu entry of a given source node. */
	buildMenuEntry : function(pParent, pSrc, pHidden) {
		let vLi, vDiv, vLnk, vTyp, vCls;
		vTyp = pSrc.children ? "b" : "l";
		vCls = "mnu_sel_no mnu_"+vTyp+" mnu_src_"+pSrc.source+" mnu_dpt_"+(scPaLib.findNodes("anc:ul.mnu_sub", pParent).length + 1)+" "+pSrc.className+" mnu_sch_"+(this.fFilter && pSrc.act ? "yes" : "no");
		vLi = scDynUiMgr.addElement("li",pParent,"",pHidden);
		vDiv = scDynUiMgr.addElement("div",vLi, "mnuLbl "+vCls);
		vLnk = scDynUiMgr.addElement("a",vDiv,"mnu_i mnu_lnk");
		if (pSrc.url) {
			vLnk.href = scServices.scLoad.getPathFromRoot(pSrc.url) + "?ts=" + scServices.id;
			vLnk.target = pSrc.target || this.fOpt.target;
		} else {
			vLnk.href = "#";
			vLnk.onclick = function(){try{if(this.fTglBtn && this.fTglBtn.className.indexOf("mnu_tgle_c")>=0) this.fTglBtn.click()} catch(e){};return false;};
		}
		vLnk.fSrc = pSrc;
		vLnk.fMgr = this;
		if (this.fFilter && !pSrc.act) vLnk.onclick = function(){return false};
		else if (pSrc.url) vLnk.onclick = function(){try{
			this.fMgr.fRequestedItem = this.fSrc;
			if (outMgr.fIsLocal) outMgr.sOnLoadPage(this.fSrc.url);
		}catch(e){}};
		vLnk.innerHTML = "<span class='mnu_sch'><span>"+pSrc.label+"</span></span>";
		if (pSrc.title) vLnk.title = pSrc.title;
		else if (this.fOpt.addTitleAttributes) vLnk.title = pSrc.label;
		pSrc.fLbl = vDiv;
		pSrc.fLi = vLi;
		pSrc.fLnk = vLnk;
	},
	/** MenuManager.buildAncestorMenus - guarantee that all ancestors of the given item are present. */
	buildAncestorMenus : function(pItem, pHidden) {
		const vAncs = [];
		let vItem = pItem;
		while(vItem.par && !vItem.fLbl){
			vAncs.push(vItem.par);
			vItem = vItem.par;
		}
		for (let i=vAncs.length-1; i>=0; i--){
			this.buildSubMenu(vAncs[i].fUl, pHidden);
		}
	},
	/** MenuManager.buildContextMenu - build a context menu of the given item. */
	buildContextMenu : function(pItem) {
		const vAncs = [];
		const vCtx = [];
		let vItem = pItem.par;
		while(vItem && vItem.url){
			vAncs.push(vItem);
			vItem = vItem.par;
		}
		for (let i=vAncs.length-1; i>=0; i--){
			const vAnc = vAncs[i];
			vCtx.push('<a href="#'+this.buildContextId(vAnc)+'" class="ctx_lnk"><span>'+vAnc.label+'</span></a>');
		}
		return vCtx.join('<span> > </span>')+(vCtx.length>0 ? '<span> > </span><span>' + pItem.label + '</span>' : '');
	},
	/** MenuManager.buildContextId - build an context id of the given item if the same item has multiple instances in the menu. */
	buildContextId : function(pItem) {
		if (!pItem) return "";
		const vPageId = outMgr.getPageIdFromUrl(pItem.url);
		if (this.fItemIndex[pItem.url].length==1) return vPageId;
		const vAncs = [pItem.idx];
		let vItem = pItem.par;
		while(vItem && vItem.url){
			vAncs.push(vItem.idx);
			vItem = vItem.par;
		}
		return vPageId + ":" + vAncs.reverse().join(".");
	},
	/** MenuManager.setConds - set the condition list and rebuild the menu. */
	setConds : function(pConds) {
		if (!this.fConds) this.fConds = {};
		for (const vCond in pConds){
			const vCondVal = this.fConds[vCond] = pConds[vCond].getValue();
			const vCondItems = this.fCondIndex[vCond];
			if (vCondItems){
				for (let i = 0; i < vCondItems.length; i++){
					const vCondItem = vCondItems[i];
					vCondItem.cnd = vCondItem.cond.value == vCondVal;
				}
			}
		}
		this.rebuildMenu();
	},
	/** MenuManager.setRequestedItemFromContextId - set the requested item from a context id. */
	setRequestedItemFromContextId : function(pContext) {
		if (!pContext) return;
		pContext = pContext.split(":");
		if (pContext.length!=2) return;
		const vId = pContext[0];
		pContext = pContext[1].split(".");
		let vCurrentItem = this.fOutline;
		try{
			for (let i = 0; i < pContext.length; i++){
				vCurrentItem = vCurrentItem.children[scCoLib.toInt(pContext[i])]
			}
			if (vCurrentItem && outMgr.getPageIdFromUrl(vCurrentItem.url) === vId) this.fRequestedItem = vCurrentItem
		} catch(e){}
	},
	/** MenuManager.setRequestedItemFromUrl - set the requested item from a url of a child of the current item or the first item with the given url. */
	setRequestedItemFromUrl : function(pUrl) {
		if (!pUrl || !this.fCurrItem) return null;
		if (this.fCurrItem.children){
			for (let i = 0; i < this.fCurrItem.children.length; i++){
				const vChildItem = this.fCurrItem.children[i];
				if (vChildItem.url === pUrl) {
					this.fRequestedItem = vChildItem;
					return;
				}
			}
		}
		const vItems = this.fItemIndex[pUrl];
		if (!vItems) return null;
		this.fRequestedItem = vItems[0];
	},
	/** MenuManager.resetMenu - reset all filtering info in the menu: . */
	resetMenu : function() {
		const iResetMenu = function (pItem) {
			pItem.act = false;
			pItem.vis = false;
			pItem.cnt = null;
			if (pItem.children) for (let i = 0; i < pItem.children.length; i++) iResetMenu(pItem.children[i]);
		};
		iResetMenu(this.fOutline);
		this.fOutline.cntAct = 0;
	},
	/** MenuManager.rebuildMenu - Rebuild the menu from scrach. */
	rebuildMenu : function() {
		const vMgr = this;
		const iResetMenu = function (pItem) {
			pItem.fLbl = null;
			pItem.fUl = null;
			pItem.fLi = null;
			if (!vMgr.fFilter) {
				pItem.act = false;
				pItem.vis = false;
				pItem.cnt = null;
			}
			if (pItem.children) for (let i = 0; i < pItem.children.length; i++) iResetMenu(pItem.children[i]);
		};
		iResetMenu(this.fOutline);
		if (!this.fFilter) this.fOutline.cntAct=0;
		this.fRoot.innerHTML = "";
		const vRootUl = scDynUiMgr.addElement("ul", this.fRoot, "mnu_root mnu_sub mnu_sch_no");
		vRootUl.fSrc = this.fOutline;
		this.buildSubMenu(vRootUl);
	},
	/** MenuManager.getRootPageUrl - return the URL of the root page. */
	getRootPageUrl : function(){
		return this.fFirstItem.url;
	},
	/** MenuManager.getFirstPageUrl - return the URL of the first visible page. */
	getFirstPageUrl : function(){
		this.fRequestedItem = (this.fFilter ? this.fFirstFilteredItem : this.fFirstItem);
		return (this.fRequestedItem ? this.fRequestedItem.url : null);
	},
	/** MenuManager.hasPage - returns true if the given url exists in this menu. */
	hasPage : function(pUrl){
		const vItems = this.fItemIndex[pUrl];
		if (vItems){
			for (let i=0; i<vItems.length; i++){
				const vItem = vItems[i];
				if (this.fFilter || (!vItem.prn)) return true
			}
		}
		return false;
	},
	/** isVisible - returns true if the given url is visible in this menu.
	 * pReason : "cnd" : check conditions only / "act" : check filter only / null : check both */
	isVisible : function(pUrl, pReason){
		const vItems = this.fItemIndex[pUrl];
		if (vItems){
			for (let i=0; i<vItems.length; i++){
				const vItem = vItems[i];
				if (!pReason && vItem.cnd && (!this.fFilter || vItem.act)) return true
				else if (pReason == "cnd" && vItem.cnd) return true
				else if (pReason == "act" && (!this.fFilter || vItem.act)) return true
			}
		}
		return false;
	},
	/** MenuManager.getNextPageUrl - return the URL of the next visible page of the given url. */
	getNextPageUrl : function(pUrl, pNoRequest){
		let vCurrItem = null;
		if (this.fCurrItem && this.fCurrItem.url == pUrl) vCurrItem = this.fCurrItem;
		if (!vCurrItem){
			const vItems = this.fItemIndex[pUrl];
			if (!vItems) return null;
			vCurrItem = vItems[0];
		}
		let vNxtItem = vCurrItem.nxt;
		while (vNxtItem && (!vNxtItem.cnd || (this.fFilter && !vNxtItem.act))) vNxtItem = vNxtItem.nxt;
		if (pNoRequest) return (vNxtItem ? vNxtItem.url : null);
		this.fRequestedItem = vNxtItem;
		return (this.fRequestedItem ? this.fRequestedItem.url : null);
	},
	/** MenuManager.getPreviousPageUrl - return the URL of the previous visible page of the given url. */
	getPreviousPageUrl : function(pUrl, pNoRequest){
		let vCurrItem = null;
		if (this.fCurrItem && this.fCurrItem.url == pUrl) vCurrItem = this.fCurrItem;
		if (!vCurrItem){
			const vItems = this.fItemIndex[pUrl];
			if (!vItems) return null;
			vCurrItem = vItems[0];
		}
		let vPrvItem = vCurrItem.prv;
		while (vPrvItem && (!vPrvItem.cnd || (this.fFilter && !vPrvItem.act))) vPrvItem = vPrvItem.prv;
		if (pNoRequest) return (vPrvItem ? vPrvItem.url : null);
		this.fRequestedItem = vPrvItem;
		return (this.fRequestedItem ? this.fRequestedItem.url : null);
	},
	/** MenuManager.getPageCount - return filtered page cout. */
	getPageCount : function(){
		return this.fOutline.cntAct;
	},
	/** MenuManager.getPageCount - return the page rank of the given url. */
	getPageRank : function(pUrl){
		let vCurrItem = null;
		if (this.fCurrItem && this.fCurrItem.url == pUrl) vCurrItem = this.fCurrItem;
		if (!vCurrItem){
			const vItems = this.fItemIndex[pUrl];
			if (!vItems) return null;
			vCurrItem = vItems[0];
		}
		return (vCurrItem ? vCurrItem.cnt : null);
	},
	/** MenuManager.applyFilter - apply a filter on the menu based on the given array of visible pages. */
	applyFilter : function(pPageList) {
		let i;
		if (this.fOpt.neverFilter) return;
		this.resetMenu();
		this.fFilter = true;
		for (i = 0; i<pPageList.length; i++){
			const vItems = this.fItemIndex[pPageList[i]];
			if (vItems){
				for (let j=0; j<vItems.length; j++){
					let vItem = vItems[j];
					if(this.isCondVisible(vItem)){
						vItem.vis = true;
						vItem.act = true;
						this.fOutline.cntAct++;
						while (vItem.par && !vItem.par.vis){
							vItem = vItem.par;
							vItem.vis = true;
						}
					}
				}
			}
		}
		let vCnt = 0;
		const iSetRank = function (pItem) {
			if (pItem.act) pItem.cnt = ++vCnt;
			if (pItem.children) {
				for (let i = 0; i < pItem.children.length; i++) iSetRank(pItem.children[i]);
			}
		};
		iSetRank(this.fOutline);
		this.rebuildMenu();
		const iFindFirstItems = function (pItem, pArray) {
			if (pItem.act) pArray.push(pItem);
			if (pArray.length >= outMgr.fMaxFilterDisplay) return true;
			if (pItem.children) {
				for (let i = 0; i < pItem.children.length; i++) if (iFindFirstItems(pItem.children[i], pArray)) return true;
			} else return false;
		};
		const vFirstItems = [];
		iFindFirstItems(this.fOutline, vFirstItems);
		for (i = 0; i<vFirstItems.length; i++){
			this.buildAncestorMenus(vFirstItems[i],false);
			this.openAncestors(vFirstItems[i]);
		}
		if (vFirstItems.length>0) this.fFirstFilteredItem = vFirstItems[0];
		outMgr.xSwitchClass(this.fRoot, "mnu_sch_no", "mnu_sch_yes");
	},
	/** MenuManager.resetFilter - resert the current filter and rebuild the menu. */
	resetFilter : function() {
		this.fFilter = false;
		this.rebuildMenu();
		this.fFirstFilteredItem = null;
		outMgr.xSwitchClass(this.fRoot, "mnu_sch_yes", "mnu_sch_no");
		if (this.fCurrItem) this.loadPage(this.fCurrItem.url);
	},
	/** MenuManager.loadPage - set the given url as the 'active' page. */
	loadPage : function(pUri) {
		let i;
		let vItems;
		if (this.fCurrItem) {
			vItems = this.fItemIndex[this.fCurrItem.url];
			for (i = 0; i<vItems.length; i++) if (vItems[i].fLbl) outMgr.xSwitchClass(vItems[i].fLbl, "mnu_sel_", "mnu_sel_no", false, false);
		}
		vItems = this.fItemIndex[pUri];
		if (!vItems) {
			if (this.fContext) this.fContext.innerHTML = "";
			this.fCurrItem = null;
			return;
		}
		let vItemPresent = false;
		for (i = 0; i<vItems.length; i++){
			const vItem = vItems[i];
			const vIsRequested = (this.fRequestedItem && this.fRequestedItem.node === vItem.node) || (!this.fRequestedItem && i == 0);
			if (!this.fOpt.selectOneEntry || vIsRequested){
				if (vItem.cnd && ((!this.fFilter && !vItem.prn) || vItem.act)){
					if (!vItem.fLbl) this.buildAncestorMenus(vItem);
					this.openAncestors(vItem);
					if (vItem.fLbl.fTglBtn && scPaLib.checkNode(outMgr.sFilterTgleClosed,vItem.fLbl.fTglBtn)) this.toggleMnuItem(vItem.fLbl.fTglBtn);
					outMgr.xSwitchClass(vItem.fLbl, "mnu_sel_", "mnu_sel_"+(vIsRequested ? "yes" : outMgr.fClassSuffixSame), false, false);
					vItemPresent = true;
				}
			}
		}
		if (!vItemPresent) {
			if (this.fContext) this.fContext.innerHTML = "";
			this.fCurrItem = null;
			return;
		}
		if (this.fRequestedItem && this.fRequestedItem.url == pUri) this.fCurrItem = this.fRequestedItem;
		else this.fCurrItem = vItems[0];
		if (this.fScrollerEnabled) this.ensureVisible();
		if (this.fContext) this.fContext.innerHTML = this.buildContextMenu(this.fCurrItem);
	},
	/** MenuManager.isCondVisible - return true if the passed item is visible calculated on it's cond status and the cond status of it's ancestors. */
	isCondVisible : function(pItem) {
		let vItem = pItem;
		if (!vItem.cnd) return false;
		while (vItem.par){
			vItem = vItem.par;
			if (!vItem.cnd) return false;
		}
		return true;
	},
	/** MenuManager.openAncestors - open all closed ancestors of the given item. */
	openAncestors : function(pItem) {
		// Make shure this label is visible (open all ancestors)
		const vClosedSubMnus = scPaLib.findNodes("anc:ul.mnu_sub_c", pItem.fLbl);
		for (let i=0; i < vClosedSubMnus.length; i++){
			this.toggleMnuItem(vClosedSubMnus[i].fTglBtn);
		}
	},
	/** MenuManager.sToggleMnuItem - sub-menu toggle button callback function. */
	sToggleMnuItem : function() {
		try{
			this.fUl.fMgr.toggleMnuItem(this);
		} catch(e){}
		return false;
	},
	/** MenuManager.toggleMnuItem - toggle the sub-menu of the given toggle button. */
	toggleMnuItem : function(pBtn) {
		if (!pBtn) return;
		const vStatus = pBtn.className;
		const vUl = pBtn.fUl;
		if (!vUl) return;
		if (!vUl.fBuilt) this.buildSubMenu(vUl);
		if(vStatus == "mnu_tgle_c") {
			pBtn.className = "mnu_tgle_o";
			pBtn.innerHTML = "<span>v</span>"
			pBtn.title = outMgr.fStrings[5].replace("%s", pBtn.fLblTxt);
			vUl.className = vUl.className.replace("mnu_sub_c", "mnu_sub_o");
			vUl.style.display = "";
			vUl.fClosed = false;
		} else {
			pBtn.className = "mnu_tgle_c";
			pBtn.innerHTML = "<span>></span>"
			pBtn.title = outMgr.fStrings[4].replace("%s", pBtn.fLblTxt);
			vUl.className = vUl.className.replace("mnu_sub_o", "mnu_sub_c");
			vUl.style.display = "none";
			vUl.fClosed = true;
			const vOpendSubMnus = scPaLib.findNodes("chi:li/chi:ul.mnu_sub_o", vUl);
			for (let i=0; i < vOpendSubMnus.length; i++) this.toggleMnuItem(vOpendSubMnus[i].fTglBtn);
		}
		if (this.fOpt.addScroller) this.checkScrollBtns();
	},
	/** MenuManager scroll timer & size task */
	fClassOffUp : "btnOff",
	fClassOffDown : "btnOff",
	fSpeed : 0,
	execTask : function(){
		try {
			if(this.fSpeed == 0) return false;
			this.fRoot.scrollTop += this.fSpeed;
			return true;
		}catch(e){
			this.fSpeed = 0;
			return false;
		}
	},
	setScrollStep: function(pPx) {
		try {this.fRoot.scrollTop += pPx;}catch(e){}
	},
	ensureVisible: function(){
		if (!this.fCurrItem) return;
		let vParent = this.fCurrItem.fLbl.offsetParent;
		if( !vParent) return;
		let vOffset = this.fCurrItem.fLbl.offsetTop;
		while(vParent != this.fRoot) {
			const vNewParent = vParent.offsetParent;
			vOffset += vParent.offsetTop;
			vParent = vNewParent;
		}
		if (vOffset < this.fRoot.scrollTop) this.fRoot.scrollTop = vOffset;
		else if (vOffset + this.fCurrItem.fLbl.offsetHeight > this.fRoot.scrollTop + this.fRoot.clientHeight) this.fRoot.scrollTop = vOffset - this.fRoot.clientHeight + this.fCurrItem.fLbl.offsetHeight;
	},
	checkScrollBtns: function(){
		const vScrollTop = this.fRoot.scrollTop;
		const vBtnUpOff = this.fSrlUp.className.indexOf(this.fClassOffUp);
		if(vScrollTop <= 0) {
			if(vBtnUpOff < 0) this.fSrlUp.className+= " "+this.fClassOffUp;
		} else {
			if(vBtnUpOff >= 0) this.fSrlUp.className = this.fSrlUp.className.substring(0, vBtnUpOff);
		}
		const vContentH = scSiLib.getContentHeight(this.fRoot);
		const vBtnDownOff = this.fSrlDwn.className.indexOf(this.fClassOffDown);
		if( vContentH - vScrollTop <= this.fRoot.offsetHeight){
			if(vBtnDownOff < 0) this.fSrlDwn.className+= " "+this.fClassOffDown;
		} else {
			if(vBtnDownOff >=0) this.fSrlDwn.className = this.fSrlDwn.className.substring(0, vBtnDownOff);
		}
	},
	onResizedAnc:function(pOwnerNode, pEvent){
		if(pEvent.phase==1 || pEvent.resizedNode == pOwnerNode) return;
		this.ensureVisible();
		this.checkScrollBtns();
	},
	onResizedDes:function(pOwnerNode, pEvent){
		if(pEvent.phase==1) return;
		this.ensureVisible();
	},
	ruleSortKey : "checkScrollBtns"

}
