/* Dokiel page manager */
window.tplMgr = {
	fHash: null,
	fCbkInit: true,
	fCbkPath: "des:.cbkClosed",
	fAnchorPath: "des:a.blockAnchor|a.part_ti_lo",
	fRefPath: "des:a.txt_coLnk_ul|.idxEntryCallerLnk|.stackLnk|.seeAlso",
	fNestedPath: "des:a.nestedTopicLnk|a.nestedThemeLnk",
	fAbsPath: "des:.nestedTopics|.idxEntryCo/des:.abstract",
	fBkBtnPath: "des:.outBkBtn/des:a",
	fClassCondFilter: scPaLib.compileFilter(".nodeChild"),
	fIsLocal: window.location.protocol == "file:",

	fStrings: ["", "",
		/*02*/      "Cacher le contenu de \'%s\'", "Afficher le contenu de \'%s\'",
		/*04*/      "", ""],

	init: function () {
		try {
			let vHash = window.location.hash;
			if (vHash.length > 0) this.fHash = vHash.substring(1);
			if (window.frameElement && window.frameElement.initPage) {
				window.frameElement.initPage(scServices.scLoad.getUrlFromRoot(scCoLib.hrefBase()), document.title, this.fHash);
			} else {
				scCoLib.log("WARNING: no initPage");
				const vLinks = document.getElementsByTagName("link");
				if (!this.fIsLocal && !window.frameElement) for (let i = 0; i < vLinks.length; i++) {
					if (vLinks[i].getAttribute("rel").indexOf("start") == 0) window.location.replace(vLinks[i].href + "?p=" + scServices.scLoad.getUrlFromRoot(scCoLib.hrefBase()) + (this.fHash ? "&h=" + this.fHash : ""))
				}
			}
			if (!this.fIsLocal && window.parent && window.parent.frameMgr) this.fStore = window.parent.frameMgr.fStore;

			//Conditions
			if (window.frameElement.hasConds()) {
				// Surcharge de dokielMgr dans un contexte de conditions dynamiques
				if ("dokielMgr" in window) dokielMgr.xIsVisible = function (pNode) {
					// Retourne 'true' si pNode et visible, 'false' si item est invisible (conditionné à false)
					let vCondVal = pNode.getAttribute("data-cond");
					if (!vCondVal) return true;
					vCondVal = vCondVal.split(":");
					const vConds = window.frameElement.getConds();
					return (vConds[vCondVal[0]].getValue() == (vCondVal[1] == "true"));
				}
			}
			this.initDom();

			// Callback functions
			if ("scDynUiMgr" in window) {
				scDynUiMgr.collBlk.addOpenListener(this.sCollBlkOpen);
				scDynUiMgr.collBlk.addCloseListener(this.sCollBlkClose);
			}
			if ("scTooltipMgr" in window) {
				scTooltipMgr.addShowListener(this.sTtShow);
				scTooltipMgr.addHideListener(this.sTtHide);
			}

			// hashChange
			window.addEventListener("hashchange", function(pEvt){
				var vHash = window.location.hash;
				if (vHash.length>0) vHash = vHash.substring(1);
				this.fHash = vHash;
				if (sc$(vHash)) window.frameElement.hashChange(this.fHash);
			}, false);

			scOnLoads[scOnLoads.length] = this;
			scOnUnloads[scOnUnload.length] = this;
		} catch (e) {
			scCoLib.log("ERROR - tplMgr.init : " + e)
		}
	},

	initDom: function () {
		//Section outline
		this.fSecOutCo = scPaLib.findNode("ide:content/des:div.secOutFra/chi:div.secOutUi");
		if (this.fSecOutCo && !scPaLib.checkNode(".static", this.fSecOutCo)) {
			this.fSecOutBtn = scPaLib.findNode("des:div.secOutFra/chi:div.secOutTi/chi:a");
			if (scPaLib.checkNode(".dynamicCollapsed", this.fSecOutCo) || (scPaLib.checkNode(".dynamicMemorized", this.fSecOutCo) && this.fStore.get("secOutCollapse") == "true") )this.secOutToggle();
		}

		// Close collapsable blocks that are closed by default.
		if (this.fCbkInit) {
			const vCbks = scPaLib.findNodes(this.fCbkPath);
			for (var i = 0; i < vCbks.length; i++) {
				if (!this.fHash || this.fHash && this.fHash != scPaLib.findNode("chi:", vCbks[i]).id) {
					const vTgl = scPaLib.findNode("des:a", vCbks[i]);
					if (vTgl) vTgl.onclick();
				}
			}
		}

		//Conditions
		const vCondItems = document.querySelectorAll("*[data-cond]");
		if (window.frameElement.hasConds()) {
			const vConds = window.frameElement.getConds();
			if (vCondItems.length > 0) {
				for (var i = 0; i < vCondItems.length; i++) {
					const vCondItem = vCondItems[i];
					const vCondVal = vCondItem.getAttribute("data-cond").split(":");
					if (!vConds[vCondVal[0]]) console.error("Condition '" + vCondVal[0] + "' is not dynamic.");
					else {
						if (scPaLib.checkNode(this.fClassCondFilter, vCondItem)) {
							if (vConds[vCondVal[0]].getValue() == (vCondVal[1] == "true")) vCondItem.classList.remove("condVisible_no");
							else vCondItem.classList.add("condVisible_no");
						} else vCondItem.style.display = vConds[vCondVal[0]].getValue() == (vCondVal[1] == "true") ? "" : "none";
					}
				}
			}
			if (scPaLib.checkNode(".tools", document.body)) {
				const vDds = scPaLib.findNodes("des:dd");
				for (var i = 0; i < vDds.length; i++) {
					const vDd = vDds[i];
					const vDt = scPaLib.findNode("psi:dt", vDd);
					const vIdxCallers = scPaLib.findNodes("des:a.idxEntryCallerLnk", vDd);
					let vNumCallers = vIdxCallers.length;
					for (let j = 0; j < vIdxCallers.length; j++) {
						const vIdxCaller = vIdxCallers[j];
						if (!window.frameElement.isPageVisible(scServices.scLoad.getUrlFromRoot(scCoLib.hrefBase(vIdxCaller.href)))) {
							scPaLib.findNode("anc:.idxEntryCaller", vIdxCaller).classList.add("condVisible_no");
							vNumCallers--;
						} else {
							scPaLib.findNode("anc:.idxEntryCaller", vIdxCaller).classList.remove("condVisible_no");
						}
					}
					if (vNumCallers < 1) {
						vDt.classList.add("condVisible_no");
						vDd.classList.add("condVisible_no");
					} else {
						vDt.classList.remove("condVisible_no");
						vDd.classList.remove("condVisible_no");
					}
				}
			}
		}

		const vAnchors = scPaLib.findNodes(this.fAnchorPath);
		for (var i = 0; i < vAnchors.length; i++) vAnchors[i].onclick = this.sAnchorClick;

		const vRefLinks = scPaLib.findNodes(this.fRefPath);
		for (var i = 0; i < vRefLinks.length; i++) vRefLinks[i].onclick = function () {
			window.frameElement.resetMenuContext(scServices.scLoad.getUrlFromRoot(scCoLib.hrefBase(this.href)));
		};

		const vNestedLinks = scPaLib.findNodes(this.fNestedPath);
		for (var i = 0; i < vNestedLinks.length; i++) vNestedLinks[i].onclick = function () {
			window.frameElement.setMenuContext(scServices.scLoad.getUrlFromRoot(scCoLib.hrefBase(this.href)));
		};

	},

	onLoad: function () {
		if (window.frameElement && window.frameElement.loadPage) {
			window.frameElement.loadPage(scServices.scLoad.getUrlFromRoot(scCoLib.hrefBase()));
		}
	},
	loadSortKey: "ZZZ",

	onUnload: function () {
		if (window.frameElement && window.frameElement.unloadPage) window.frameElement.unloadPage();
	},

	secOutToggle: function () {
		if (!this.fSecOutCo || !this.fSecOutBtn) return false;
		scDynUiMgr.collBlkToggle(this.fSecOutBtn, this.fSecOutCo, "secOut_op", "secOut_cl");
		if (this.fStore) this.fStore.set("secOutCollapse", this.fSecOutCo.style.display == "none");
		return false;
	},

	makeVisible: function (pNode) {
		// Ouvre bloc collapsable contenant pNode
		const vCollBlks = scPaLib.findNodes("anc:.collBlk_closed", pNode);
		for (let i=0; i<vCollBlks.length; i++){
			vCollBlks[i].fTitle.onclick();
		}
	},

	setExpandAll: function (pExpand) {
		if ("dokielMgr" in window) {
			if (pExpand) dokielMgr.cancelStepMode();
			dokielMgr.setInteractiveScreenMode(!pExpand);
		}
		if ("scSiLib" in window) scSiLib.fireResizedNode(sc$("page"));
	},

	/* === Callback functions =================================================== */
	/** Tooltip lib show callback */
	sTtShow: function (pNode) {
		if (!pNode.fOpt.FOCUS && !pNode.onblur) pNode.onblur = function () {
			scTooltipMgr.hideTooltip(true);
		};
	},
	/** Tooltip lib hide callback : this = scTooltipMgr */
	sTtHide: function (pNode) {
		if (pNode) pNode.focus();
	},
	/** Collapable block Callback functions. */
	sCollBlkOpen: function (pCo, pTitle) {
		if (pTitle) pTitle.title = tplMgr.fStrings[2].replace("%s", (pTitle.innerText ? pTitle.innerText : pTitle.textContent));
	},
	sCollBlkClose: function (pCo, pTitle) {
		if (pTitle) pTitle.title = tplMgr.fStrings[3].replace("%s", (pTitle.innerText ? pTitle.innerText : pTitle.textContent));
	},
	sAnchorClick: function () {
		if (window.frameElement && window.frameElement.loadPage) {
			window.frameElement.loadPage(scServices.scLoad.getUrlFromRoot(scCoLib.hrefBase()), document.title, this.hash.substring(1));
		}
	},

	/* === Utilities ============================================================ */
	/** tplMgr.xAddBtn : Add a HTML button to a parent node. */
	xAddBtn: function (pParent, pClassName, pCapt, pTitle, pNxtSib) {
		const vBtn = pParent.ownerDocument.createElement("a");
		vBtn.className = pClassName;
		vBtn.fName = pClassName;
		vBtn.href = "#";
		vBtn.target = "_self";
		if (pTitle) vBtn.setAttribute("title", pTitle);
		if (pCapt) vBtn.innerHTML = "<span>" + pCapt + "</span>"
		if (pNxtSib) pParent.insertBefore(vBtn, pNxtSib)
		else pParent.appendChild(vBtn);
		return vBtn;
	},

	/** tplMgr.xSwitchClass - replace a class name. */
	xSwitchClass: function (pNode, pClassOld, pClassNew, pAddIfAbsent, pMatchExact) {
		const vAddIfAbsent = typeof pAddIfAbsent == "undefined" ? false : pAddIfAbsent;
		const vMatchExact = typeof pMatchExact == "undefined" ? true : pMatchExact;
		const vClassName = pNode.className;
		const vReg = new RegExp("\\b" + pClassNew + "\\b");
		if (vMatchExact && vClassName.match(vReg)) return;
		let vClassFound = false;
		if (pClassOld && pClassOld != "") {
			if (vClassName.indexOf(pClassOld) == -1) {
				if (!vAddIfAbsent) return;
				else if (pClassNew && pClassNew != '') pNode.className = vClassName + " " + pClassNew;
			} else {
				const vCurrentClasses = vClassName.split(' ');
				const vNewClasses = new Array();
				let i = 0;
				const n = vCurrentClasses.length;
				for (; i < n; i++) {
					const vCurrentClass = vCurrentClasses[i];
					if (vMatchExact && vCurrentClass != pClassOld || !vMatchExact && vCurrentClass.indexOf(pClassOld) != 0) {
						vNewClasses.push(vCurrentClasses[i]);
					} else {
						if (pClassNew && pClassNew != '') vNewClasses.push(pClassNew);
						vClassFound = true;
					}
				}
				pNode.className = vNewClasses.join(' ');
			}
		}
		return vClassFound;
	}
};

/* responsive management */
window.responsive = {
	fListeners: {scrollChange: []},
	fPrevScrollpos: window.scrollY,
	init: function () {
		try {
			window.onscroll = function () {
				const vCurrentScrollPos = window.scrollY;
				responsive.fPrevScrollpos = vCurrentScrollPos;
				responsive.fireEvent("scrollChange", vCurrentScrollPos);
			};
		} catch (e) {
			scCoLib.log("ERROR - responsive.init : " + e)
		}
	},
	registerListener: function (pListener, pFunc) {
		if (this.fListeners[pListener]) this.fListeners[pListener].push(pFunc);
	},
	fireEvent: function (pListener, pParam) {
		if (this.fListeners[pListener]) {
			for (let i = 0; i < this.fListeners[pListener].length; i++) {
				try {
					this.fListeners[pListener][i](pParam);
				} catch (e) {
				}
			}
		}
	}
};
